﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class Form1
   Private moLine As LineShape
   Private moMap As WinformsMap
   Dim moTempDrawingLayer As InMemoryFeatureLayer = New InMemoryFeatureLayer()

   Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
      Dim oTempDrawingOverlay As New LayerOverlay
      Dim oPolygon As PolygonShape
      Dim oBufferResult As MultipolygonShape
      Dim oFeature As Feature
      Dim oShapefile As ShapeFileFeatureLayer
      Dim oStateFeature As Feature
      Dim oStateFeatures As Collection(Of Feature)
      Dim oPoint As PointShape
      Dim oPointBuffer As PolygonShape


      moTempDrawingLayer.Name = "TempLayer"
      moMap = WinformsMap1
      moMap.MapUnit = GeographyUnit.DecimalDegree
      With oTempDrawingOverlay
         .Name = "TempOverlay"
         .Layers.Add("TempLayer", moTempDrawingLayer)
         moMap.Overlays.Add("TempOverlay", oTempDrawingOverlay)
         moMap.Overlays.MoveToTop(oTempDrawingOverlay)
         moLine = CType(LineBaseShape.CreateShapeFromWellKnownData("LINESTRING(-87.2356830286108 35.8781973440737,-87.1198182279843 33.9278065335276,-91.7737210531489 32.8657125277846)"), LineShape)
         oFeature = New Feature(moLine)
         moTempDrawingLayer.InternalFeatures.Add(oFeature)

         oBufferResult = moLine.Buffer(100000, 30, BufferCapType.Round, GeographyUnit.DecimalDegree, DistanceUnit.Meter)

         oPolygon = oBufferResult.Polygons(0)

         oFeature = New Feature(oPolygon)
         moTempDrawingLayer.InternalFeatures.Add("BufferPoly", oFeature)

         moTempDrawingLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Black, 1, False)
         moTempDrawingLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)

         moTempDrawingLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

         ShapeFileFeatureLayer.BuildIndexFile("..\..\Data\Alabama.shp", BuildIndexMode.DoNotRebuild)
         oShapefile = New ShapeFileFeatureLayer("..\..\Data\Alabama.shp")
         .Layers.Add("Shapefile", oShapefile)
         oShapefile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.GeographicColors.InnerState, 1)
         oShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
         oShapefile.Open()
         'oStateFeatures = oShapefile.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns)
         'For Each oStateFeature In oStateFeatures
         '   If oStateFeature.ColumnValues.Item("statename").ToUpper.Contains("ALABAMA") Then
         '      oPoint = moLine.GetCrossing(oStateFeature.GetShape).Points(0)
         '      Exit For
         '   End If
         'Next oStateFeature

         'oPointBuffer = oPoint.Buffer(0.0000000015783, 50, BufferCapType.Round, GeographyUnit.Meter, DistanceUnit.Meter).Polygons(0)

         'moTempDrawingLayer.InternalFeatures.Add(New Feature(oPointBuffer))

      End With


      mBufferLine()
   End Sub

   Private Sub btnBuffer_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnBuffer.Click
      mBufferLine()
   End Sub
   Private Sub mBufferLine()
      Dim dBufferWidth As Double
      With moTempDrawingLayer
         If Not .IsOpen Then
            .Open()
         End If
      End With
      Dim oFeature As Feature = moTempDrawingLayer.FeatureSource.GetFeatureById("BufferPoly", ReturningColumnsType.NoColumns)
      Try

         If IsNumeric(txtBuffer.Text) Then
            dBufferWidth = CDbl(txtBuffer.Text)
            Dim oBufferResult As PolygonShape = moLine.Buffer(dBufferWidth, 30, BufferCapType.Round, moMap.MapUnit, DistanceUnit.Meter).Polygons(0)
            With moTempDrawingLayer.EditTools
               .BeginTransaction()
               moTempDrawingLayer.InternalFeatures.Remove("BufferPoly")
               moTempDrawingLayer.InternalFeatures.Add("BufferPoly", New Feature(oBufferResult))
               .CommitTransaction()
               moMap.CurrentExtent = oBufferResult.GetBoundingBox
               moMap.Refresh()
            End With
         End If
      Catch ex As Exception
         MessageBox.Show("ERROR: " & ex.Message, "Error buffering line.", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try
   End Sub
End Class
